#include <cmath>
#include <iostream>
#include "suite1.hpp"
using namespace std;

suite1 & suite1::operator = (const suite1 & x){
  
  if(this != & x){ // autoaffectation
    n = x.n;

    if(b != NULL){
      delete  [] b;
      b = NULL; }
    if(A != NULL){
      delete  [] A;
      A = NULL;  }
    if(un != NULL){
      delete  [] un;
      un = NULL; }

    if(x.b != NULL && x.un != NULL && x.A != NULL){
      b = new double[n];
      un = new double[n];
      A = new double[n*n];
      int k=0;
      for(int i =0; i<n;i++){
  	b[i] = x.b[i];
	un[i] = x.un[i];
	for(int j =0; j<n;j++){
	  A[indice_k(i,j)] = x.A[indice_k(i,j)];
	}
      }
    }
  }
  return *this;
}
suite1 suite1::operator + (const suite1 & x){
  suite1 res(n);
  if(n != x.n){ 
    cout<<" on ne peut pas sommer avec n gauche et droite différent " <<endl;
  }
  else {
    int k =0;
    for(int i =0; i<n;i++){
      res.b[i] = b[i] + x.b[i];
      res.un[i] = un[i] + x.un[i];
      for(int j =0; j<n;j++){
	res.A[indice_k(i,j)] = A[indice_k(i,j)] + x.A[indice_k(i,j)];
	cout<<"i >> "<<i<<"j >>"<<j<<" A "<<res.A[indice_k(i,j)]<<endl;
      }
    }
  }
  return res;
}
void suite1::set_bi(int i , double x){
  b[i] = x;
}

void suite1::set_u0i(int i , double x){
  un[i] = x;
}

void suite1::set_Aij(int i, int j , double x){
  A[indice_k(i,j)] = x;
}

void suite1::set_bi(int i , double * x){
  if(x != NULL){ 
    cout<<" on ne peut pas faire l'affectation car l'objet est nul " <<endl;
  }
  else {
    for(int i =0; i<n;i++){
      b[i] = x[i];
    }
  }
}


void suite1::set_u0i(int i , double * x){
  if(x != NULL){ 
    cout<<" on ne peut pas faire l'affectation car l'objet est nul " <<endl;
  }
  else {
    for(int i =0; i<n;i++){
      un[i] = x[i];
    }
  }
}

void suite1::set_Aij(int i, int j , double * x){
  if(x != NULL){ 
    cout<<" on ne peut pas faire l'affectation car l'objet est nul " <<endl;
  }
  else {
    for(int i =0; i<n*n;i++){
      A[i] = x[i];
    }
  }
}

void suite1::term_n(int niter){
  double * u = new double[n];
  double sum;
  for(int ni =0; ni<niter;ni++){
    for(int i =0; i<n;i++){
  	u[i] = un[i];
    }
    for(int i =0; i<n;i++){
      sum=0;
      for(int j =0; j<n;j++){
	sum = sum + A[indice_k(i,j)]*u[j];
      }
      u[i] = sum + b[i];
    }
    for(int i =0; i<n;i++){
  	un[i] = u[i];
    }
  }
}

void suite1::plot_un(){

    for(int i =0; i<n;i++){
      cout<<"ieme terme de un :"<<un[i]<<endl;;
    }

}

