#include <cmath>
#include <iostream>
#include "suite2.hpp"
#include "suite1.hpp"

using namespace std;

int main (){

  suite1 xn(3);

  xn.set_bi(0,1.2);
  xn.set_bi(1,1.5);
  xn.set_bi(2,1.7);

  xn.set_Aij(0,0,1.0);
  xn.set_Aij(1,1,1.0);
  xn.set_Aij(2,2,1.0);

  suite1 yn(3);

  yn.set_Aij(0,0,1.0);
  yn.set_Aij(0,1,2.0);
  yn.set_Aij(0,2,-0.5);
  yn.set_Aij(1,1,2.0);
  yn.set_Aij(1,2,3.0);
  yn.set_Aij(2,2,1.2);

  suite1 zn;
  zn = xn+yn;
  zn.term_n(3);
  zn.plot_un();

  suite2<double,3> xn2;
  xn2.set_bi(0,1.2);
  xn2.set_bi(1,1.5);
  xn2.set_bi(2,1.7);

  xn2.set_Aij(0,0,1.0);
  xn2.set_Aij(1,1,1.0);
  xn2.set_Aij(2,2,1.0);

  suite2<double,3> yn2;
  
  yn2.set_Aij(0,0,1.0);
  yn2.set_Aij(0,1,2.0);
  yn2.set_Aij(0,2,-0.5);
  yn2.set_Aij(1,1,2.0);
  yn2.set_Aij(1,2,3.0);
  yn2.set_Aij(2,2,1.2);

  suite2<double,3> zn2;
  zn2 = xn2+yn2;
  zn2.term_n(3);
  zn2.plot_un();
  return 0;
};

